#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
#define sz(x) ((ll)x.size())
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define F first
#define S second
typedef long long ll;
typedef unsigned long long ull;

const ll MAX_N = 101;
vector <pair<ll, ll> > g[MAX_N];

struct Node {
    ll a, k, dist;
};

const ll inf = 1e9;
bool operator < (const Node& a, const Node& b) {return a.dist > b.dist;}
ll dist[MAX_N][MAX_N];

ll dij(ll a, ll b, ll k) {
    priority_queue<Node> pq;
    pq.push({a, 0, 0});
    dist[0][0] = 0;
    while(!pq.empty()) {
        Node curr = pq.top(); pq.pop();
        if(curr.a == b && curr.k == k) {return curr.dist;}
        //cout << curr.a << " " << curr.k << " " << curr.dist << endl;
        for(ll i = 0; i < g[curr.a].size(); i ++) {
            ll next = g[curr.a][i].F, nextD = g[curr.a][i].S;
            if(dist[next][curr.k + 1] > curr.dist + nextD) {
                dist[next][curr.k + 1] = curr.dist + nextD;
                pq.push({next, curr.k + 1, dist[next][curr.k + 1]});
            }
        }
    }
    return -1;
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);
    ll n, m, k, a, b;
    cin >> n >> m >> k >> a >> b;
    for(ll i = 0; i < m; i++) {
        ll a, b, d;
        cin >> a >> b >> d;
        g[a].push_back({b, d});
    }
    for(ll i =  0; i < MAX_N; i ++) {for(ll j = 0; j < MAX_N; j ++) {dist[i][j] = inf;} }
    cout << dij(a, b, k);
    return 0;
}

/*
5 5 4 0 4
0 1 1
1 2 4
1 3 2
2 4 2
3 4 1
*/

/*
5 6 2 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
*/

/*
5 6 3 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
*/
