#include<iostream>
#include<vector>
#include<queue>
using namespace std;
int n, m, k, a, b;
int l, r, p, u, wh;

vector<pair<int, int> > sys[128];
int path[128][128];

struct nod
{
    int path;
    int node;
    int when;

    bool operator < (nod A) const
    {
        return path > A.path;
    }

};

priority_queue<nod> dijkstra;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    for(int i = 0; i < 128; i++){
        for(int j = 0; j < 128; j++){
            path[i][j] = -1;
        }
    }

    cin >> n >> m >> k >> a >> b;
    for(int i = 0; i < m; i++){
        cin >> l >> r >> p;
        sys[l].push_back({r, p});
    }
    nod A;
    A.path = 0;
    A.node = a;
    A.when = 0;
    dijkstra.push(A);
    while(!dijkstra.empty()){
        A = dijkstra.top();
        dijkstra.pop();
        u = A.node;
        wh = A.when;
        p = A.path;
        if(path[u][wh] != -1 || wh > k){
            continue;
        }
        path[u][wh] = p;
        /*if(u == b && wh == k){
            cout << p << endl;
            return 0;
        }*/
        if(wh == k){
            continue;
        }
        for(int i = 0; i < sys[u].size(); i++){
            if(path[sys[u][i].first][wh+1] == -1){
                dijkstra.push({p + sys[u][i].second, sys[u][i].first, wh+1});

            }
        }
    }
    cout << path[b][k] << endl;
return 0;
}
/*
5 6 2 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2


*/
