#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define fi first
#define se second
#define endl '\n'
using namespace std;

const int MAXN = 100;
const int INF = 1000000000;

vector< pair<int, int> > G[MAXN + 5];
bool used[MAXN + 5];
int dist[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, k, a, b;
    cin >> n >> m >> k >> a >> b;

    int u, v, w;
    for (int i = 0; i < m; ++ i)
    {
        cin >> u >> v >> w;
        G[u].push_back(make_pair(v, w));
    }

    priority_queue< pair< pair<int, int>, int > > pq;
    pq.push(make_pair(make_pair(0, a), 0));

    int ans = INF;
    while (!pq.empty())
    {
        int u = pq.top().fi.se, d = -pq.top().fi.fi, kk = pq.top().se;
        pq.pop();
        if (u == b and kk == k) ans = min(ans, d);
        for (int i = 0; i < G[u].size(); ++ i)
            if (kk < k) pq.push(make_pair(make_pair(-(d + G[u][i].se), G[u][i].fi), kk + 1));
    }

    if (ans == INF) cout << -1 << endl;
    else cout << ans << endl;

    return 0;
}
