#include <iostream>
#include <vector>
using namespace std;
vector <pair <int,int> > v[128];
bool street[128][128];
int dp[128][128], a, b;
int searchAns(int x, int k) {
    if (k==0) {
        if (x==a) return dp[x][k]=0;
        else return dp[x][k]=-1;
    }
    if (dp[x][k]!=-1) return dp[x][k];
    int s;
    for (int i=0;i<v[x].size();i++) {
        if (!street[x][v[x][i].first]) continue;
        street[x][v[x][i].first]=false;
        s=searchAns(v[x][i].first,k-1);
        street[x][v[x][i].first]=true;
        if (s>-1) {
            if (dp[x][k]==-1) dp[x][k]=s+v[x][i].second;
            else dp[x][k]=min(dp[x][k],s+v[x][i].second);
        }
    }
    return dp[x][k];
}
int main () {
    int n, m, k, c, d, e;
    cin >> n >> m >> k >> a >> b;
    for (int i=0;i<m;i++) {
        cin >> c >> d >> e;
        v[d].push_back(make_pair(c,e));
        street[d][c]=true;
    }
    for (int i=0;i<n;i++) {
        for (int j=0;j<=k;j++) dp[i][j]=-1;
    }
    cout << searchAns(b,k) << endl;
    return 0;
}
/**
5 6 3 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
**/
