#include <iostream>
#define endl '\n'
using namespace std;
int cif[16], c[32];
long long dp[16][256], ss[16];
const long long mod=1000000000;
long long modul(long long x) {
    if (x<mod) return x;
    return x%mod;
}
void addOne(int j) {
    if (ss[j]==0) {
        dp[j][0]=1;
        ss[j]=1;
        return;
    }
    long long r, c=0;
    r=dp[j][0]+1;
    if (r==mod) c=1;
    dp[j][0]=modul(r);
    for (int i=1;i<ss[j];i++) {
        if (c==0) break;
        r=dp[j][i]+c;
        c=r/mod;
        dp[i][j]=modul(r);
    }
    if (c>0) {
        dp[j][ss[j]]=1;
        ss[j]++;
    }
}
void add(int j) {
    if (ss[j]==0) {
        ss[j]=ss[j-1];
        for (int i=0;i<ss[j];i++) dp[j][i]=dp[j-1][i];
        return;
    }
    long long r, c=0, r1, r2, s;
    s=max(ss[j],ss[j-1]);
    for (int i=0;i<s;i++) {
        if (i>=ss[j]) r1=0;
        else r1=dp[j][i];
        if (i>=ss[j-1]) r2=0;
        else r2=dp[j-1][i];
        r=r1+r2+c;
        c=r/mod;
        dp[j][i]=modul(r);
    }
    ss[j]=s;
    if (c>0) {
        dp[j][ss[j]]=c;
        ss[j]++;
    }
}
void printcif(long long x, int s) {
    int br=0;
    if (x==0) {
        if (s>1) for (int i=0;i<9;i++) cout << 0;
        else cout << 0;
        return;
    }
    while (x>0) {
        c[br]=x%10;
        br++;
        x/=10;
    }
    for (int i=br-1;i>=0;i--) cout << c[i];
}
void print(int ind) {
    for (int i=ss[ind]-1;i>=0;i--) {
        printcif(dp[ind][i],ss[ind]);
    }
    cout << endl;
}
int main () {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    for (int i=0;i<k;i++) {
        cin >> cif[i];
    }
    int l, br;
    for (int i=1;i<=n;i++) {
        l=i;
        br=0;
        while (l>0) {
            c[br]=l%10;
            br++;
            l/=10;
        }
        br--;
        while (br>=0) {
            for (int j=k-1;j>=0;j--) {
                if (c[br]==cif[j]) {
                    if (j>0 && dp[j-1]>0) add(j);
                    if (j==0) addOne(j);
                    /**
                    cout << i << ' ' << j << ' ';
                    for (int l=ss[j]-1;l>=0;l--) cout << dp[j][l];
                    cout << endl;
                    **/
                }
            }
            br--;
        }
    }
    print(k-1);
    return 0;
}
/**
40 3
1 2 3
**/
