#include <iostream>
#include <vector>
using namespace std;
const int INFINITY=1<<30;
struct street{
    int to, toll;
};
vector <street> graph[100];
int used[100], n, m, k, a, b, minPath=INFINITY;
void init()
{
    street temp;
    int from, to, toll;
    cin>>n>>m>>k>>a>>b;
    for (int i=0; i<m; i++){
        cin>>from>>to>>toll;
        temp.to=to;
        temp.toll=toll;
        graph[from].push_back(temp);
    }
    for (int i=0; i<n; i++){
        used[i]=INFINITY;
    }
    used[a]=0;
}
void djikstra(int from, int to, int currNum)
{
    int vSize=graph[from].size();
    if (from==to and currNum==k){
        if (used[from]<minPath) minPath=used[from];
        return;
    }
    if (currNum>k){
        used[from]=-1;
        return;
    }
    for (int i=0; i<vSize; i++){
        //if (used[from]+graph[from][i].toll<=used[graph[from][i].to]){
            used[graph[from][i].to]=used[from]+graph[from][i].toll;
        //}
        djikstra(graph[from][i].to, to, currNum+1);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    init();
    djikstra(a, b, 0);
    if (minPath<INFINITY) cout<<minPath<<endl;
    else cout<<"-1"<<endl;
    /*for (int i=0; i<n; i++){
        cout<<used[i]<<" ";
    }
    cout<<endl;
    cout<<minPath<<endl;*/

    return 0;
}
/**
5 6 2 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
-----------------
5 6 3 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
*/
