#include<iostream>
#include<vector>
#include<queue>
#include<utility>
#define endl '\n'
#define MAXN 101
#define INF 1<<30
using namespace std;
vector<pair<int,int>>graph[MAXN];
int dist[MAXN],steps[MAXN];
priority_queue<pair<int,pair<int,int>>>dijkstra;
int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,k,a,b;
    cin>>n>>m>>k>>a>>b;
    for(int i=0;i<m;i++){
        int x,y,z;
        cin>>x>>y>>z;
        graph[x].push_back({y,z});
    }
    for(int i=0;i<MAXN;i++) dist[i]=INF;
    dist[a]=0;
    dijkstra.push({-dist[a],{a,0}});
    while(!dijkstra.empty()){
        int curr=dijkstra.top().second.first,counter=dijkstra.top().second.second;
        dijkstra.pop();
        //cout<<curr<<" "<<counter<<endl;
        for(pair<int,int> next : graph[curr]){
            if((dist[curr]+next.second<dist[next.first] or counter+1>steps[next.first]) and counter+1<=k){
                steps[next.first]=counter+1;
                dist[next.first]=dist[curr]+next.second;
                dijkstra.push({-dist[next.first],{next.first,counter+1}});
            }
        }
    }
    if(dist[b]==INF or steps[b]<k){
        cout<<-1<<endl;
    }else{
        cout<<dist[b]<<endl;
    }
return 0;
}
/**
5 6 2 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
*/
/**
5 6 3 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
*/
