#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define fi first
#define se second
#define endl '\n'
using namespace std;

const short MAXN = 100;
const short INF = 1000000000;

vector< pair<short, short> > G[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    short n, m, k, a, b;
    cin >> n >> m >> k >> a >> b;

    short u, v, w;
    for (short i = 0; i < m; ++ i)
    {
        cin >> u >> v >> w;
        G[u].push_back(make_pair(v, w));
    }

    priority_queue< pair< pair<short, short>, short > > pq;
    pq.push(make_pair(make_pair(0, a), 0));

    short ans = INF;
    while (!pq.empty())
    {
        short u = pq.top().fi.se, d = -pq.top().fi.fi, kk = pq.top().se;
        pq.pop();
        if (u == b and kk == k)
        {
            ans = d;
            break;
        }
        for (short i = 0; i < G[u].size(); ++ i)
            if (kk < k) pq.push(make_pair(make_pair(-(d + G[u][i].se), G[u][i].fi), kk + 1));
    }

    if (ans == INF) cout << -1 << endl;
    else cout << ans << endl;

    return 0;
}
