#include <iostream>
#include <unordered_map>
#include <vector>
#include <utility>
#define endl '\n'
#define ll long long
#define ull unsigned long long
#define pb push_back
//#define back front
using namespace std;
int n, m, k, a, b;

vector<pair<char, char> > nbrs[101];
unordered_map<char, short> bfs;
unordered_map<char, short> buf;

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(NULL);
   cout.tie(NULL);
   cin >> n >> m >> k >> a >> b;
   for (int i = 0; i < m; ++i) {
    int p, q, w;
    cin >> p >> q >> w;
    nbrs[p].pb({q,w});
    }
    bfs.insert({a, 0});
    bfs[a] = 0;
    for (int i = 0; i < k; ++i) {
        int s = bfs.size();
        while(!bfs.empty()) {
            buf.insert(*bfs.begin());
            bfs.erase(bfs.begin());
        }
        for (int j = 0; j < s; ++j) {
            auto it = buf.begin();
            for (int l = 0; l < nbrs[(*it).first].size(); ++l) {
                if( bfs.count(nbrs[(*it).first][l].first)==0 || (*it).second+nbrs[(*it).first][l].second < bfs[nbrs[(*it).first][l].first])
                bfs.insert({nbrs[(*it).first][l].first, (*it).second+nbrs[(*it).first][l].second});
            }
            buf.erase(it);
        }
        /*for (auto it = bfs.begin(); it!=bfs.end(); it++)
        cout << (short)(*it).first << " " << (*it).second << "  ";
        cout << endl;*/
    }
    short minimum = 20000;
    while (!bfs.empty()) {
        auto it = bfs.begin();
        if ((*it).first == b && (*it).second < minimum) {
            minimum=  (*it).second;
        }
        bfs.erase(it);
    }
    if(minimum == 20000)
        cout << -1 << endl;
    else
        cout << minimum << endl;
    return 0;
}
/*
5 6 2 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2

5 6 3 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2

6 8 3 1 6
0 1 3
0 5 1
0 4 11
1 6 13
1 3 8
5 2 9
3 4 2
4 6 4

*/
